<?php
/*
 * Plugin Name: Gallery Scroll
 * Plugin URI: http://bagtoons.com/gallery-plugin
 * Description: This plugin overides the standard gallery behavior so that a 'View as Slideshow' button will be displayed above a gallery that activates a scrollable overlay containing large versions of the gallery pics. If a gallery thumbnail is clicked the overlay will display the large version of the clicked thumbnail, and also allow the user to scroll back and forth through the gallery. If the button is clicked the first picture in the gallery is displayed in the overlay and you can scroll through the gallery manually from there.
 * Author: Mark Harris
 * Version: 1.0
 * Author URI: http://markharris.bagtoons.com
 */

function gallery_scroll_the_content_filter($content) {
    wp_enqueue_script('gallery_jquery', plugins_url('/jquery.js', __FILE__));
    wp_enqueue_script('gallery_jquery_tools', plugins_url('/jquery.tools.tabs.min.js', __FILE__));
    wp_enqueue_script('gallery_script', plugins_url('/script.js', __FILE__));
    wp_enqueue_style('gallery_style', plugins_url('/style.css', __FILE__));
    wp_localize_script('gallery_script', 'MyAjax', array('ajaxurl' => admin_url('admin-ajax.php')));

    $pattern = '/(\[gallery\s+)(?:link=".+"\s+)?(columns="\d+"\s+)?(?:link=".+"\s+)?(ids="(.+)"\])/';
    preg_match($pattern, $content, $matches);
    $gallery_pics = explode(',', $matches[4]);

    $js_array = "[";
    $concat_str = '';
    foreach ($gallery_pics as $value) {
        $js_array .= $concat_str . $value;
        $concat_str = ', ';
    }
    $js_array .= ']';

    $replacement = '<button onclick="galleryScrollStart(' . $js_array . ', 0)">View As Slideshow</button><br /><br />
        $1link="none" $2$3';
    $content = preg_replace($pattern, $replacement, $content);

    wp_localize_script('gallery_script', 'GalleryIDs', $gallery_pics);

    return $content;

}

add_filter('the_content', 'gallery_scroll_the_content_filter');
add_action('wp_ajax_gallery', 'gallery_callback');
add_action('wp_ajax_nopriv_gallery', 'gallery_callback');

function gallery_callback() {
    ob_clean();

    $gallery_ids = $_POST['GalleryIDs'];

    /*
      $args = array(
      'post_mime_type' => 'image',
      'post_parent' => $id,
      'post_status' => null,
      'post_type' => 'attachment'
      );


      $attachments = get_children($args);
      ksort($attachments);* */

    if ($gallery_ids) {
        ?>
        <div id="slideshow-close"></div>
        <!-- "previous slide" button -->
        <a class="backward">prev</a>

        <!-- container for the slides -->
        <div class="images">

            <?php
            foreach ($gallery_ids as $id) {
                $image_attributes = wp_get_attachment_image_src($id, array(620, 450));
                $position_left = round((620 - $image_attributes[1]) / 2);
                ?>

                <!-- slide -->
                <div style="left: <?php echo $position_left ?>px"><img src="<?php echo $image_attributes[0]; ?>" width="<?php echo $image_attributes[1]; ?>" height="<?php echo $image_attributes[2]; ?>" /></div>

                <?php
            }
            ?>

        </div>

        <!-- "next slide" button -->
        <a class="forward">next</a>

        <!-- the tabs -->
        <div class="slidetabs">

            <?php for ($i = 1; $i <= count($gallery_ids); $i++) { ?>

                <a href="#"></a>

            <?php } ?>

        </div>

        <?php
    }

    die();

}
?>
